%% OBSLUZNY SKRIPT PRO CTENI MIDI
% MIDI soubory nahrajte prosim do podadresare midi. Podadresar ./src
% obsahuje doplnkove funkce pro cteni MIDI souboru. O cteni MIDI souboru se
% tedy jiz nemusite vubec starat. Vasim ukolem je navrhnout syntezu 
% jednotlivych not. Jednotlive noty se syntetizuji ve funkci synth.m, jejiz 
% kostru naleznete v korenovem adresari. Sve reseni syntezy prosim doplnte 
% do teto kostry. Napovedu a pokyny naleznete v hlavicce funkce midi2synth
% a synth. Blizsi informace o cislech jednotlivych typu nastroju naleznete 
% v dokumentu MIDI_instrument_table.pdf.
%
% Upravene funkce pro cteni MIDI souboru vychazi z puvodniho navrhu Ken 
% Schutte (kenschutte@gmail.com) a jsou dostupne vcetne dokumentace na 
% http://kenschutte.com/midi podle GPL.

%% Synteza Vami nastaveneho soloveho nastroje (CTRL + ENTER)
addpath .\src .\midi % Pridani cesty ke skriptum a souborum MIDI
midi = readmidi('BWV846.mid');
[y,Fs] = midi2synth(midi,48e3);
y=y-mean(y); y=y./max(abs(y)); % normalizace (prevence prebuzeni signalu)
audiowrite('BWV846.wav',y,Fs);
rmpath .\src .\midi

%% Polyfonni synteza - cisla nastroju podle midi-souboru (CTRL + ENTER)
addpath .\src .\midi % Pridani cesty ke skriptum a souborum MIDI
midi = readmidi('Vltava.mid');
[y,Fs] = midi2synth(midi,48e3);
y=y-mean(y); y=y./max(abs(y)); % normalizace (prevence prebuzeni signalu)
audiowrite('Vltava.wav',y,Fs);
rmpath .\src .\midi

%% Stupnice
% a) Vypoctete si vektor frekvenci durove stupnice v rozsahu odpovidajicim
%    nastroji.
%
% b) Zvolte si rozumnou dobu trvani tonu.
%
% c) Syntetizujte jednotlive noty pomoci funkce synth.m
%
% d) Vysledny audio zaznam stupnice zapiste do wav souboru (nezapomente
%    signal normalizovat)



