function y=synth(freq,dur,amp,Fs,synthtype,channel)
% y=synth(freq,dur,amp,Fs,type)
% Tato funkce realizuje syntezu jedine noty. Pro realizaci syntezy
% potrebujete znat:
%
% freq - frekvence noty
% dur - trvani noty
% amp - amplituda v rozsahu [0, 1]
% Fs - vzorkovaci frekvenci
% synthtype - cislo nastroje podle MIDI (viz. MIDI_instrument_table.pdf)
% channel (nepovinny udaj) - cislo kanalu (kanal 10 je vyhrazen perkusim a 
% ridi se vlastni tabulkou nastroju viz. MIDI_intrument_table.pdf)
% 
% Tato kostra pochazi z puvodni funkce synth.m navrzene panem Ken Schutte 
% (kenschutte@gmail.com). Puvodni funkce synth a funkce pro cteni MIDI jsou 
% dostupne vcetne dokumentace na http://kenschutte.com/midi podle GPL.

if nargin==5
    channel=1;
end

N = floor(dur*Fs); % pocet vzorku v note
t = (0:N-1)./Fs;

%% Podle standardni tabulky nastroju
if channel~=10;
    if synthtype<64
        tau = 0.1;  % doznivani
        y = amp.*exp(-t/tau).*sin(2*pi*freq*t);
    else
        y = amp.*square(2*pi*freq*t);
    end 
end
%% Podle tabulky perkusnich nastroju (kanal 10)
if channel==10;
    if synthtype>50
        y=randn(size(t));
    else
        tau = 0.01;  % doznivani
        y = amp.*exp(-t/tau).*randn(size(t));
    end 
end
